#if !defined(AFX_GPSSET_H__199D7980_7451_11D3_92B5_0000E826141B__INCLUDED_)
#define AFX_GPSSET_H__199D7980_7451_11D3_92B5_0000E826141B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GpsSet.h : header file
//

#define GPS_NOOPERATION   50
#define GPS_ADDTARGET     51
#define GPS_EDITTARGET    52


/////////////////////////////////////////////////////////////////////////////
// CGpsSet command target

class CGpsSet : public CCmdTarget
{
	DECLARE_DYNCREATE(CGpsSet)

	CGpsSet();           // protected constructor used by dynamic creation

// Attributes
public:

// Operations
public:
	void SetStartXY(double X,double Y);
	double StartX;//x 
	double StartY;//y

	double dSpeed;
	double dDirectory;//


	double m_dCX;//ǰλX
	double m_dCY;//ǰλY

	CString strName;
    int m_nFeaID;




// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGpsSet)
	public:
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	BOOL HitTest(double x, double y,CMapX* pMapX);
	void Run();
	
	void AddFeature(CMapX* pMapX,CMapXLayer& layer);
	CMapXFeature FindFeature(CMapXLayer &layer);
	void UpdateFeature(CMapXFeature& feature);
	void UpdateGraph(CMapXLayer& layer);
	virtual ~CGpsSet();

	// Generated message map functions
	//{{AFX_MSG(CGpsSet)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////
// CGpsSetArray command target

class CGpsSetArray : public CCmdTarget
{
	DECLARE_DYNCREATE(CGpsSetArray)

	CGpsSetArray();           // protected constructor used by dynamic creation

// Attributes
public:
	CObArray m_ObjectList;
// Operations
public:
	void UpdateGraph(CMapXLayer& layer);
	void Run();
	void DeleteAllTarget();
	CGpsSet* m_pActiveTarget;
	CGpsSet* GetTarget(int nIndex);
	void AddTarget(CGpsSet* target);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGpsSetArray)
	//}}AFX_VIRTUAL

// Implementation
public:
	CGpsSet* GetActiveTarget();
	void SetActiveTarget(CGpsSet* pTarget);
	CGpsSet* HitTest(double X,double Y,CMapX* pMapX);
	virtual ~CGpsSetArray();

	// Generated message map functions
	//{{AFX_MSG(CGpsSetArray)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GPSSET_H__199D7980_7451_11D3_92B5_0000E826141B__INCLUDED_)
